package function

import (
	"encoding/json"
	"github.com/pkg/errors"
	"gitlab.smartblocklab.com/smartcontracts/cryptocurrencyCC/mngr"
	"gitlab.smartblocklab.com/smartcontracts/common/model/requests"
	"gitlab.smartblocklab.com/smartcontracts/common/model/cryptocurrencyCC"
	"gitlab.smartblocklab.com/smartcontracts/common/chaincode"
)

func AddCryptocurrencies(userParameter *requests.Parameter, systemParameter *requests.Parameter, manager chaincode.IManager) (interface{}, error) {
	var addCryptocurrenciesArg cryptocurrencyCC.AddCryptocurrenciesArg
	err := json.Unmarshal(systemParameter.Param, &addCryptocurrenciesArg)
	if err != nil {
		return nil, errors.Errorf("Can't unmarshal systemParameter to AddCryptocurrenciesArg. Error: %s", err)
	}

	return mngr.GetCryptocurrencyManager(manager).AddCryptocurrencies(systemParameter.UserID, addCryptocurrenciesArg.CryptocurrencyListInput)
}
