package mngr

import (
	"fmt"
	"gitlab.smartblocklab.com/smartcontracts/common/model/cryptocurrencyCC"
	"gitlab.smartblocklab.com/smartcontracts/common/model/requests"
	"github.com/pkg/errors"
)

// получаем список не обработанных криптовалют
func (this *CryptocurrencyManagerImpl) GetCryptocurrenciesByDaemonName(daemonName *requests.Id) (*cryptocurrencyCC.CryptocurrencyStoreOutput, error) {
	if len(daemonName.Id) == 0 {
		return nil, errors.New("daemonName is empty")
	}

	lastImportKeysData, err := this.getLastImportKeys()
	if err != nil {
		return nil, fmt.Errorf(err.Error())
	}

	cryptocurrencyStoreOutput := cryptocurrencyCC.CryptocurrencyStoreOutput{}
	for foundDaemonName, externalTransactionIdMap := range lastImportKeysData.MapDaemonNameKeys {
		if daemonName.Id == foundDaemonName {
			for transactionId := range externalTransactionIdMap {
				cryptocurrencyStore, err := this.getCryptocurrencyStore(transactionId)
				if err == nil && cryptocurrencyStore != nil {
					cryptocurrencyStoreOutput.CryptocurrencyStoreList = append(cryptocurrencyStoreOutput.CryptocurrencyStoreList, cryptocurrencyStore)
				}
			}
		}
	}

	return &cryptocurrencyStoreOutput, nil
}
