package mngr

import (
	"encoding/json"
	"github.com/pkg/errors"
	"gitlab.smartblocklab.com/smartcontracts/common/model/cryptocurrencyCC"
)

func (this *CryptocurrencyManagerImpl) getCryptocurrencyStore(externalTransactionID string) (*cryptocurrencyCC.CryptocurrencyStore, error) {
	cryptocurrencyStoreByteArray, err := this.GetState(externalTransactionID)
	if err != nil {
		return nil, errors.Errorf("Failed to retreive by externalTransactionID %s. Error: ", externalTransactionID, err)
	}

	if cryptocurrencyStoreByteArray == nil {
		return nil, nil
	}

	var cryptocurrencyStore cryptocurrencyCC.CryptocurrencyStore
	err = json.Unmarshal(cryptocurrencyStoreByteArray, &cryptocurrencyStore)
	if err != nil {
		return nil, errors.Errorf("Invalid lastImportKeys input format, failed due to %s", err)
	}

	return &cryptocurrencyStore, nil
}
