package mngr

import (
	"encoding/json"
	"github.com/pkg/errors"
	"gitlab.smartblocklab.com/smartcontracts/common/model/cryptocurrencyCC"
)

// получить список последних импортированных ключей
func (this *CryptocurrencyManagerImpl) getLastImportKeys() (*cryptocurrencyCC.LastImportKeys, error) {
	var lastImportKeys cryptocurrencyCC.LastImportKeys
	lastImportKeysByteArray, err := this.GetState(cryptocurrencyCC.LAST_IMPORT_KEYS)
	if err != nil {
		return nil, errors.Errorf("Failed to retreive LAST_IMPORT_KEYS. Error: %s", err)
	}

	if len(lastImportKeysByteArray) == 0 {
		lastImportKeys.MapDaemonNameKeys = cryptocurrencyCC.DaemonNameKeys{}
		return &lastImportKeys, nil
	}

	err = json.Unmarshal(lastImportKeysByteArray, &lastImportKeys)
	if err != nil {
		return nil, errors.Errorf("Invalid lastImportKeys input format, failed due to %s", err)
	}

	if lastImportKeys.MapDaemonNameKeys == nil {
		lastImportKeys.MapDaemonNameKeys = cryptocurrencyCC.DaemonNameKeys{}
	}

	return &lastImportKeys, nil
}
