package mngr

import (
	"gitlab.smartblocklab.com/smartcontracts/common/model/cryptocurrencyCC"
)

// проверить существет текущая транзакция в списке ранее импортированных ключей
func (t *CryptocurrencyManagerImpl) isKeyExists(daemonName string, lastImportKeys cryptocurrencyCC.LastImportKeys, cryptocurrencyInput cryptocurrencyCC.CryptocurrencyInput) bool {
	if len(lastImportKeys.MapDaemonNameKeys) == 0 {
		return false
	}

	daemonKeys, ok := lastImportKeys.MapDaemonNameKeys[daemonName]
	if len(daemonKeys) == 0 || !ok {
		return false
	}

	isTransactionID, ok := daemonKeys[cryptocurrencyInput.ExternalTransactionID]
	if ok && isTransactionID {
		return true
	}

	return false
}
