package mngr

import (
	"gitlab.smartblocklab.com/smartcontracts/common/remote/remote_account"
	"gitlab.smartblocklab.com/smartcontracts/common/remote/remote_transaction"
	"gitlab.smartblocklab.com/smartcontracts/common/interfaces/iaccount"
	"gitlab.smartblocklab.com/smartcontracts/common/interfaces/itransaction"
	"gitlab.smartblocklab.com/smartcontracts/common/invoke"
	"gitlab.smartblocklab.com/smartcontracts/common/interfaces/icryptocurrency"
	"gitlab.smartblocklab.com/smartcontracts/common/chaincode"
)

type CryptocurrencyManagerImpl struct {
	chaincode.IManager
	iaccount.IAccountManager
	itransaction.ITransactionManager
}

func GetCryptocurrencyManager(manager chaincode.IManager) icryptocurrency.ICryptocurrencyManager {
	accountRemoteManager := remote_account.GetAccountRemoteManager(manager, invoke.AccountChannel, invoke.AccountCC)
	transactionRemoteManager := remote_transaction.GetTransactionRemoteManager(manager, invoke.TransactionChannel, invoke.TransactionCC)
	return &CryptocurrencyManagerImpl{manager, accountRemoteManager, transactionRemoteManager}
}

func GetCryptocurrencyManagerImpl(manager chaincode.IManager) *CryptocurrencyManagerImpl {
	accountRemoteManager := remote_account.GetAccountRemoteManager(manager, invoke.AccountChannel, invoke.AccountCC)
	transactionRemoteManager := remote_transaction.GetTransactionRemoteManager(manager, invoke.TransactionChannel, invoke.TransactionCC)
	return &CryptocurrencyManagerImpl{manager, accountRemoteManager, transactionRemoteManager}
}
