package mngr

import (
	"encoding/json"
	"gitlab.smartblocklab.com/smartcontracts/common/chaincode"
	"github.com/pkg/errors"
	"gitlab.smartblocklab.com/smartcontracts/common/model/cryptocurrencyCC"
)

// сохранить последние импортированные ключи
func (this *CryptocurrencyManagerImpl) saveLastImportKeys(lastImportKeys cryptocurrencyCC.LastImportKeys) error {
	chaincode.GlobalLogger.Info("SaveLastImportKeys")

	jsonLastImportKeys, err := json.Marshal(lastImportKeys)
	if err != nil {
		return errors.Errorf("Failed to marhsal lastImportKeys. Error: %s", err)
	}

	err = this.PutState(cryptocurrencyCC.LAST_IMPORT_KEYS, jsonLastImportKeys)
	if err != nil {
		return errors.Errorf("Failed to PutState LAST_IMPORT_KEYS. Error: %s", err)
	}
	return nil
}
