package chaincode

import (
	"gitlab.smartblocklab.com/smartcontracts/common/model/requests"
)

func ClearLedger(userParameter *requests.Parameter, systemParameter *requests.Parameter, manager IManager) (interface{}, error) {
	GlobalLogger.Info("ClearLedger")

	selector, err := GetSelector(nil)
	if err != nil {
		return nil, err
	}

	it, err := manager.GetQueryResult(selector)
	if err != nil {
		return nil, err
	}

	if it == nil {
		return nil, nil
	}

	defer it.Close() // Do not forget to close iterator once get used
	for it.HasNext() {
		kv, err := it.Next()
		if err != nil {
			return nil, err
		}

		err = manager.DelState(kv.Key)
		if err != nil {
			return nil, err
		}
	}
	return nil, nil
}
