package itransaction

import (
	"gitlab.smartblocklab.com/smartcontracts/common/model/transactionCC"
	"gitlab.smartblocklab.com/smartcontracts/common/model/requests"
)

type ITransactionManager interface {

	// invoke

	LockFundsOnAccount(txnArgs *transactionCC.TxnFundsLockInput) error
	LockOutFundsOnAccount(txnArgs *transactionCC.OutTxnFundsLockInput) error
	TransferFunds(operationId *requests.Id) (*transactionCC.TransferFundsResponseList, error)
	UnlockFundsOnAccount(operationId *requests.Id) (*transactionCC.TransferFundsResponseList, error)
	LoadCryptocurrency(systemUserID string) (*transactionCC.LoadCryptocurrencyResultList, error)

	LockTransferToMarket(txnArgs *transactionCC.OutTxnFundsLockInput) error
	LoadMarketFounds(operationID *requests.Id) (*transactionCC.LoadCryptocurrencyResultList, error)
	WithdrawalMarketFounds(findLockAmountByOperationIDAndUserIdArg transactionCC.FindLockAmountByOperationIDAndUserIdArg) error

	// query

	CheckExistsTransactionByList(syncRequest *transactionCC.SyncRequest) (*transactionCC.CheckExistsResult, error)
	GetUsersTransaction(userId *requests.Id) (*transactionCC.UserTransactionsList, error)
	FindLockAmountByOperationIDAndUserId(findLockAmountByOperationIDAndUserIdArg transactionCC.FindLockAmountByOperationIDAndUserIdArg) (*transactionCC.FindLockAmountResult, error)
	AccountCurrencyBalance(accountCurrencyBalanceArg transactionCC.AccountCurrencyBalanceArg) (*transactionCC.AccountBalance, error)
}
