package transactionCC

type Timestamp int64

func (timestamp Timestamp) String() string {
	return string(timestamp)
}

type InputOutputType string

func (inputOutputType InputOutputType) String() string {
	return string(inputOutputType)
}

const (
	INPUT  InputOutputType = "INPUT"
	OUTPUT InputOutputType = "OUTPUT"
)

// ProcessType denote possible process types for transactions
type ProcessType string

func (processType ProcessType) String() string {
	return string(processType)
}

// Enumerate transactions process types
const (
	ExchangeWithBothCommission_ProcessType  ProcessType = "EXCHANGE_WITH_BOTH_COMMISSION"
	TransferSenderCommissions_ProcessType   ProcessType = "TRANSFER_SENDER_COMMISSIONS"
	TransferReceiverCommissions_ProcessType ProcessType = "TRANSFER_RECEIVER_COMMISSIONS"
	DepositFunds_ProcessType                ProcessType = "DEPOSIT_FUNDS"
	WithdrawalFunds_ProcessType             ProcessType = "WITHDRAWAL_FUNDS"
	TransferToMarket_ProcessType            ProcessType = "TRANSFER_TO_MARKET"
	CreateMarketOrder_ProcessType           ProcessType = "CREATE_MARKET_ORDER"
	CancelMarketOrder_ProcessType           ProcessType = "CANCEL_MARKET_ORDER"
)

// OperationType define operation types
type OperationType string

const (
	LockAmount                 OperationType = "LOCK_AMOUNT"
	LockCommission             OperationType = "LOCK_COMMISSION"
	TransferAmountToUser       OperationType = "TRANSFER_AMOUNT_TO_USER"
	TransferCommissionToSystem OperationType = "TRANSFER_COMMISSION_TO_SYSTEM"
	UnlockAmount               OperationType = "UNLOCK_AMOUNT_TO_USER"
	UnlockCommission           OperationType = "UNLOCK_COMMISSION_TO_USER"
)

func (c OperationType) String() string {
	return string(c)
}
